#include "OPNoise.hlsl"

struct VS_INPUT
{
	float4 position : POSITION;
};

struct VS_OUTPUT
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
};

struct PS_INPUT
{
	float2 texCoord : TEXCOORD0;
};

VS_OUTPUT main_vp(VS_INPUT input)
{
	VS_OUTPUT output;

	input.position.xy = sign(input.position.xy);
	output.position = float4(input.position.xy, 0, 1);

	output.texCoord.x = 0.5 * (1 + output.position.x);
	output.texCoord.y = 0.5 * (1 - output.position.y);
	
	return output;
}

float4 main_fp(PS_INPUT input, uniform float time) : COLOR
{
	return float4(0.0, 1.0, 0.0, 1.0);
}