uniform sampler2D reflectionTexture : register(s0);
uniform sampler2D refractionTexture : register(s1);
uniform sampler2D normalTexture : register(s2);

struct VS_INPUT
{
	float4 position : POSITION;
};

struct VS_OUTPUT
{
	float4 position		: POSITION;
	float3 positionWS	: TEXCOORD0;
};

struct PS_INPUT
{
	float3 positionWS	: TEXCOORD0;
};

struct PS_OUTPUT
{
	float4 depth	: COLOR;
};

VS_OUTPUT main_vp(VS_INPUT input,
		uniform float4x4 world,
		uniform float4x4 worldViewProj)
{
	VS_OUTPUT output;

	output.position = mul(worldViewProj, input.position);
	output.positionWS = mul(world, input.position);

	return output;
}

PS_OUTPUT main_fp(PS_INPUT input,
		uniform float3 cameraPosition)
{
	PS_OUTPUT output;

	output.depth = float4(length(input.positionWS - cameraPosition), 0.0, 0.0, 1.0);

	return output;
}