struct VS_INPUT
{
	float4 position : POSITION;
};

struct VS_OUTPUT
{
	float4 position		: POSITION;
	float3 positionWS	: TEXCOORD0;
};

struct PS_INPUT
{
	float3 positionWS	: TEXCOORD0;
};

struct PS_OUTPUT
{
	float4 color	: COLOR;
};

VS_OUTPUT main_vp(VS_INPUT input,
		uniform float4x4 world,
		uniform float4x4 worldViewProj)
{
	VS_OUTPUT output;

	output.position = mul(worldViewProj, input.position);
	output.positionWS = mul(world, input.position);

	return output;
}

PS_OUTPUT main_fp(PS_INPUT input,
		uniform float3 cameraPosition,
		uniform float4 waterFogColor,
		uniform float4 materialVariables)
{
	PS_OUTPUT output;

	float depth = length(input.positionWS - cameraPosition);
	float f = 1.0 - 1 / exp(pow(depth * materialVariables.z, 2));
	output.color = float4(waterFogColor.xyz, max(f, 0.5));

	return output;
}