struct VS_INPUT
{
	float4 position : POSITION;
};

struct VS_OUTPUT
{
	float4 position			: POSITION;
	float2 texCoord			: TEXCOORD0;
};

struct PS_INPUT
{
	float2 texCoord			: TEXCOORD0;
};

struct PS_OUTPUT
{
	float4 color	: COLOR;
};

VS_OUTPUT main_vp(VS_INPUT input,
		uniform float4x4 worldViewProj)
{
	VS_OUTPUT output;

    // Use standardise transform, so work accord with render system specific (RS depth, requires texture flipping, etc)
    output.position = mul(worldViewProj, input.position);

    // The input positions adjusted by texel offsets, so clean up inaccuracies
    input.position.xy = sign(input.position.xy);

    // Convert to image-space
    output.texCoord = (float2(input.position.x, -input.position.y) + 1.0f) * 0.5f;

	return output;
}