uniform sampler2D Scene : register(s0);
uniform sampler2D RT : register(s1);
uniform sampler2D SceneDepthTexture : register(s2);

#include "OWPPEffect.hlsl"

PS_OUTPUT main_fp(PS_INPUT input,
		uniform float4 waterFogColor,
		uniform float4 materialVariables)
{
	PS_OUTPUT output;

	float depth = tex2D(SceneDepthTexture, input.texCoord).r;
	float3 sceneColor = tex2D(Scene, input.texCoord).rgb;
	float3 blurredColor = tex2D(RT, input.texCoord).rgb;

	float f = min(saturate(1 / exp(pow(depth * materialVariables.z, 2))), 0.5);
	float blur = saturate(1 / exp(pow(depth * materialVariables.w, 2)));

	sceneColor = blur * sceneColor + (1-blur) * blurredColor;

	output.color = float4(f * sceneColor + (1-f) * waterFogColor.rgb, 1.0);
	return output;
}