uniform sampler2D RT : register(s0);

static const float gaussianWeights[11] = {
	0.01222447,
	0.02783468,
	0.06559061,
	0.12097757,
	0.17466632,
	0.19741265,
	0.17466632,
	0.12097757,
	0.06559061,
	0.02783468,
	0.01222447
};

#include "OWPPEffect.hlsl"

PS_OUTPUT main_fp(PS_INPUT input,
				uniform float4 viewportSize)
{
	PS_OUTPUT output;

	output.color = float4(0.0, 0.0, 0.0, 1.0);

	for (int i = 0; i < 11; ++i)
	{
		output.color.rgb += gaussianWeights[i] * tex2D(RT, float2((i-5) * viewportSize.x + input.texCoord.x, input.texCoord.y)).rgb;
	}

	return output;
}