uniform sampler2D tex : register(s0);

struct VS_INPUT
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
};

struct VS_OUTPUT
{
	float4 position		: POSITION;
	float2 texCoord		: TEXCOORD0;
	float3 positionWS	: TEXCOORD1;
};

struct PS_INPUT
{
	float2 texCoord		: TEXCOORD0;
	float3 positionWS	: TEXCOORD1;
};

struct PS_OUTPUT
{
	float4 depth	: COLOR;
};

VS_OUTPUT main_vp(VS_INPUT input,
		uniform float4x4 world,
		uniform float4x4 worldViewProj)
{
	VS_OUTPUT output;

	output.position = mul(worldViewProj, input.position);
	output.positionWS = mul(world, input.position);
	output.texCoord = input.texCoord;

	return output;
}

PS_OUTPUT main_fp(PS_INPUT input,
		uniform float3 cameraPosition)
{
	PS_OUTPUT output;

	output.depth = float4(length(input.positionWS - cameraPosition), 0.0, 0.0, tex2D(tex, input.texCoord).a);

	return output;
}